package com.example.services.impl;

import com.alibaba.fastjson.JSONObject;
import com.example.MyResult;
import com.example.api.R;
import com.example.entity.ContainerRegisterQuery;
import com.example.entity.OutCenter;
import com.example.services.IService;

import javax.jws.WebService;
import java.util.concurrent.Semaphore;
import java.util.concurrent.TimeUnit;

/**
 * Created by wangh on 2021/1/14-10:29。
 */
@WebService(
        targetNamespace ="http://service.example.com/" ,
        serviceName = "authorService",           //服务name名称
        portName = "authorPortName",
        endpointInterface = "com.example.services.IService")//指定发布webservcie的接口类，此类也需要接入@WebService注解
public class ServiceImpl implements IService {

    private static boolean m_GetInCenterStartSuccessful;
    private static boolean m_GetInCenterStopSuccessful;
    private static boolean m_GetOutCenterStartSuccessful;
    private static boolean m_GetOutCenterStopSuccessful;
    private static final Semaphore m_RecData = new Semaphore(1);

    public boolean DealValidPack(String ValidData){
        try {
            if(!ValidData.isEmpty()||!ValidData.equals("")){
//                m_RecData.release();
                switch (ValidData){
                    case "101":
                        m_GetInCenterStartSuccessful = true;
                        break;
                    case "102":
                        m_GetInCenterStopSuccessful = true;
                        break;
                    case "103":
                        m_GetOutCenterStartSuccessful = true;
                        break;
                    case"104":
                        m_GetOutCenterStopSuccessful = true;
                        break;
                    default:
                        m_GetInCenterStartSuccessful = true;
                        break;
                }
            }
        }
        catch (Exception ex){
            return false;
        }
        return true;
    }
    //请求地址 http://localhost:8090/services/mPerson?wsdl
    @Override
//    public MyResult getScanInfoInCenterStart(String messageHeader,
//                                             String ContainerRegisterQuery,
//                                             String opOrgCode,
//                                             String userCode,
//                                             String userName,
//                                             String province,
//                                             String pdaip) {
        public R getScanInfoInCenterStart(
            String messageHeader,
            String opOrgCode,
            String userCode,
            String userName,
            String province,
            String pdaip) {
            boolean isSendFlag = false;
        //示例
        ContainerRegisterQuery containerRegisterQuery1 = new ContainerRegisterQuery();
        containerRegisterQuery1.setMessageHeader(messageHeader);
        containerRegisterQuery1.setOpOrgCode(opOrgCode);
        containerRegisterQuery1.setUserCode(userCode);
        containerRegisterQuery1.setUserName(userName);
        containerRegisterQuery1.setProvince(province);
        containerRegisterQuery1.setPdaip(pdaip);
        containerRegisterQuery1.setCommandCode(101);
        String json = JSONObject.toJSONString(containerRegisterQuery1);
        if(WebSocketServerContent.getSocket(pdaip, json)){
            try {
                Thread.sleep(2000);
                if(m_GetInCenterStartSuccessful){
                    isSendFlag = true;
                    m_GetInCenterStartSuccessful = false;
                    return R.data(200,"向客户端发送消息成功！");
                }
                else {
                    System.out.println("《《《等待客户端返回消息超时！");
                    isSendFlag = false;
                    return R.data(201,"向客户端发送消息成功，接收客户端消息超时！");
                }
//                if(m_RecData.tryAcquire(2000, TimeUnit.MILLISECONDS)) {
//                    if(m_GetDataSuccessful){
//                        isSendFlag = true;
//                        m_GetDataSuccessful = false;
//                        return R.data(200,"success");
//                    }
//                    else {
//                        System.out.println("《《《等待客户端返回消息超时！");
//                        isSendFlag = false;
//                        m_GetDataSuccessful = false;
//                        return R.data(401,"timeout");
//                    }
//                }
//                else{
//                    System.out.println("《《《等待信号量释放超时！");
//                    isSendFlag = false;
//                    return R.data(402,"semtimeout");
//                }

            }catch (Exception ex){
                return R.data(100,"向客户端发送消息失败！");
            }
        }
        else {
            return R.data(101,"向客户端发送消息失败！");
        }
    }

    @Override
    public R getScanInfoInCenterStop(
            String messageHeader, String opOrgCode, String userCode, String userName, String province,
            String pdaip) {
        boolean isSendFlag = false;
        //示例
        ContainerRegisterQuery containerRegisterQuery2 = new ContainerRegisterQuery();
        containerRegisterQuery2.setMessageHeader(messageHeader);
        containerRegisterQuery2.setOpOrgCode(opOrgCode);
        containerRegisterQuery2.setUserCode(userCode);
        containerRegisterQuery2.setUserName(userName);
        containerRegisterQuery2.setProvince(province);
        containerRegisterQuery2.setPdaip(pdaip);
        containerRegisterQuery2.setCommandCode(102);
        String json = JSONObject.toJSONString(containerRegisterQuery2);
        if(WebSocketServerContent.getSocket(pdaip, json)){
            try {
                Thread.sleep(2000);
                if(m_GetInCenterStopSuccessful){
                    isSendFlag = true;
                    m_GetInCenterStopSuccessful = false;
                    return R.data(200,"向客户端发送消息成功！");
                }
                else {
                    System.out.println("《《《等待客户端返回消息超时！");
                    isSendFlag = false;
                    return R.data(201,"向客户端发送消息成功，接收客户端消息超时！");
                }
            }catch (Exception ex){
                return R.data(100,"向客户端发送消息失败！");
            }
        }
        else {
            return R.data(101,"向客户端发送消息失败！");
        }
    }

    @Override
    public R getScanInfoOutCenterStart(String messageHeader, String containerRegisterQuery, String opOrgCode, String opOrgName, String userCode, String userName, String provice, String rqzlmc, String zbid, String destinationOrgName, String destinationOrgCode, String rqzl, String rqxh, String rqxhmc, String pdaip) {
        boolean isSendFlag = false;
        //示例
        OutCenter outCenter1 = new OutCenter();
        outCenter1.setMessageHeader(messageHeader);
        outCenter1.setOpOrgCode(opOrgCode);
        outCenter1.setOpOrgName(opOrgName);
        outCenter1.setUserCode(userCode);
        outCenter1.setUserName(userName);
        outCenter1.setProvice(provice);
        outCenter1.setRqzlmc(rqzlmc);
        outCenter1.setZbid(zbid);
        outCenter1.setDestinationOrgName(destinationOrgName);
        outCenter1.setDestinationOrgCode(destinationOrgCode);
        outCenter1.setRqzl(rqzl);
        outCenter1.setRqxh(rqxh);
        outCenter1.setRqxhmc(rqxhmc);
        outCenter1.setPdaip(pdaip);
        outCenter1.setCommandCode(103);
        String json = JSONObject.toJSONString(outCenter1);
        if(WebSocketServerContent.getSocket(pdaip, json)){
            try {
                Thread.sleep(2000);
                if(m_GetOutCenterStartSuccessful){
                    isSendFlag = true;
                    m_GetOutCenterStartSuccessful = false;
                    return R.data(200,"向客户端发送消息成功！");
                }
                else {
                    System.out.println("《《《等待客户端返回消息超时！");
                    isSendFlag = false;
                    return R.data(201,"向客户端发送消息成功，接收客户端消息超时！");
                }
            }catch (Exception ex){
                return R.data(100,"向客户端发送消息失败！");
            }
        }
        else {
            return R.data(101,"向客户端发送消息失败！");
        }
    }

    @Override
    public R getScanInfoOutCenterStop(String messageHeader, String containerRegisterQuery, String opOrgCode, String opOrgName, String userCode, String userName, String provice, String rqzlmc, String zbid, String destinationOrgName, String destinationOrgCode, String rqzl, String rqxh, String rqxhmc, String pdaip) {
        boolean isSendFlag = false;
        //示例
        OutCenter outCenter2 = new OutCenter();
        outCenter2.setMessageHeader(messageHeader);
        outCenter2.setOpOrgCode(opOrgCode);
        outCenter2.setOpOrgName(opOrgName);
        outCenter2.setUserCode(userCode);
        outCenter2.setUserName(userName);
        outCenter2.setProvice(provice);
        outCenter2.setRqzlmc(rqzlmc);
        outCenter2.setZbid(zbid);
        outCenter2.setDestinationOrgName(destinationOrgName);
        outCenter2.setDestinationOrgCode(destinationOrgCode);
        outCenter2.setRqzl(rqzl);
        outCenter2.setRqxh(rqxh);
        outCenter2.setRqxhmc(rqxhmc);
        outCenter2.setPdaip(pdaip);
        outCenter2.setCommandCode(104);
        String json = JSONObject.toJSONString(outCenter2);
        if(WebSocketServerContent.getSocket(pdaip, json)){
            try {
                Thread.sleep(2000);
                if(m_GetOutCenterStopSuccessful){
                    isSendFlag = true;
                    m_GetOutCenterStopSuccessful = false;
                    return R.data(200,"向客户端发送消息成功！");
                }
                else {
                    System.out.println("《《《等待客户端返回消息超时！");
                    isSendFlag = false;
                    return R.data(201,"向客户端发送消息成功，接收客户端消息超时！");
                }
            }catch (Exception ex){
                return R.data(100,"向客户端发送消息失败！");
            }
        }
        else {
            return R.data(101,"向客户端发送消息失败！");
        }
    }
}
